"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelHelperVueJsxMergeProps = require("babel-helper-vue-jsx-merge-props");

var _babelHelperVueJsxMergeProps2 = _interopRequireDefault(_babelHelperVueJsxMergeProps);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'ElTablePlus',
  props: {
    currentChangeAsync: {
      type: Function
    },
    columns: {
      type: Array,
      default: []
    },
    pageSize: {
      type: Number,
      default: 20
    }
  },
  data: function data() {
    return {
      data: [],
      loading: false,
      currentPage: 1,
      total: 0
    };
  },

  computed: {
    hasPagination: function hasPagination() {
      return !!this.currentChangeAsync;
    }
  },
  methods: {
    reload: function reload() {
      this.handleCurrentChange(1);
    },
    handleCurrentChange: function handleCurrentChange(currentPage) {
      this.currentPage = currentPage;
      this.getData();
    },
    getData: function getData() {
      var _this = this;

      return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var _ref, data, total;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this.loading = true;

                _context.next = 3;
                return _this.currentChangeAsync(_this.currentPage, _this.pageSize);

              case 3:
                _ref = _context.sent;
                data = _ref.data;
                total = _ref.total;


                _this.data = data;
                _this.total = total;
                _this.loading = false;

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    }
  },
  render: function render(h) {
    return h(
      "div",
      { "class": "el-table-plus" },
      [(this.$slots.caption || this.$slots.actionBar) && h(
        "div",
        { "class": "el-table-plus__header" },
        [h(
          "h1",
          { "class": "el-table-plus__header__caption" },
          [this.$slots.caption]
        ), h(
          "div",
          { "class": "el-table-plus__header__action-bar" },
          [this.$slots.actionBar]
        )]
      ), h(
        "el-table",
        (0, _babelHelperVueJsxMergeProps2.default)([{ ref: "table", attrs: { data: this.data },
          directives: [{
            name: "loading",
            value: this.loading
          }]
        }, { props: this.$attrs }, { on: this._events }]),
        [this.columns.map(function (column) {
          var nextColumn = (0, _extends3.default)({}, column, {
            formatter: column.formatter && function (row) {
              return column.formatter(row[column.prop]);
            }
          });

          return nextColumn.renderBody ? h(
            "el-table-column",
            (0, _babelHelperVueJsxMergeProps2.default)([{ props: nextColumn }, {
              scopedSlots: {
                default: function _default(_ref2) {
                  var row = _ref2.row;

                  return nextColumn.renderBody(h, row);
                }
              } }]),
            []
          ) : h(
            "el-table-column",
            { props: nextColumn },
            []
          );
        })]
      ), this.hasPagination && h(
        "el-pagination",
        {
          attrs: { "current-page": this.currentPage, "page-size": this.pageSize,
            total: this.total,
            layout: "total, prev, pager, next" },
          on: {
            "current-change": this.handleCurrentChange
          }
        },
        []
      )]
    );
  }
};